#ifndef CTEST1_H
#define CTEST1_H

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>
#include <strings.h>
#include <errno.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>


#include "global.h"

///
/// \brief The TParamCTest1 struct параметры теста 1
///
struct TParamCTest1 {
    int mSpeed;             ///< скорость
    int mParityBit;         ///< бит чётности
    int mReverce;           ///< реверс
    int mMode;              ///< режим
    int mPrintTimeout;      ///< период выдачи информации в сек
    int mCountMessages;     ///< кол-во сообщений, отправленных за один такт
};

///< скорость
#define T_CTEST1_SPEED          ((char)'s')
///< чётность
#define T_CTEST1_PARITY         ((char)'p')
///< реверс
#define T_CTEST1_REVERCE        ((char)'r')
///< режим
#define T_CTEST1_MODE           ((char)'m')
///< таймаут
#define T_CTEST1_TIMEOUT        ((char)'t')
///< кол-во сообщений
#define T_CTEST1_CNT_MSG        ((char)'c')

extern char configFileName[];           ///< имя файла конфигурации, считанного из аргументов
extern char fullConfigFileName[];       ///< полное имя файла конфигурации в папке config
extern struct TParamCTest1 params;      ///< параметры теста 1
extern struct TChannel* channels;       ///< каналы
extern struct TDevice* devices;         ///< девайсы

///
/// \brief main точка входа в программу
/// \param argc кол-во аргументов
/// \param argv аргументы
/// \return код возврата
///
int main(int argc, char* argv[]);
///
/// \brief constructFullConfigFileName построить полное имя файла конфигурации
/// \param fullname полное имя
/// \param size размер
/// \param name имя
///
void constructFullConfigFileName(char* fullname, int size, char* name);
///
/// \brief readConfigFile чтение конфигурации из файла
/// \param fullname полное имя файла конфигурации
/// \param params параметры теста
/// \return код результата
///
int readConfigFile(char* fullname, struct TParamCTest1* params);
///
/// \brief procCTest1 процедура консольного теста 1
/// \param params параметры теста
///
void procCTest1(struct TParamCTest1 params);
///
/// \brief initLogCTest1 настройка логов теста 1
///
void initLogCTest1(void);
///
/// \brief initDefaultParamsCTest1 инициализация параметров ао-умолчанию теста 1
/// \param params параметры теста
///
void initDefaultParamsCTest1(struct TParamCTest1* params);

#endif // CTEST1_H
