#ifndef CTEST2_H
#define CTEST2_H

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>
#include <strings.h>
#include <errno.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>


#include "global.h"

///
/// \brief The TParamCTest2 struct параметры теста 2
///
struct TParamCTest2 {
    int mSpeed;             ///< скорость
    int mParityBit;         ///< бит чётности
    int mReverce;           ///< реверс
    int mPrintTimeout;      ///< период выдачи информации в сек
};

///< скорость
#define T_CTEST2_SPEED          ((char)'s')
///< чётность
#define T_CTEST2_PARITY         ((char)'p')
///< реверс
#define T_CTEST2_REVERCE        ((char)'r')
///< таймаут
#define T_CTEST2_TIMEOUT        ((char)'t')

extern char configFileName[];           ///< имя файла конфигурации, считанного из аргументов
extern char fullConfigFileName[];       ///< полное имя файла конфигурации в папке config
extern struct TParamCTest2 params;      ///< параметры теста 2
extern struct TChannel* channels;       ///< каналы
extern struct TDevice* devices;         ///< девайсы

///
/// \brief main точка входа в программу
/// \param argc кол-во аргументов
/// \param argv аргументы
/// \return код возврата
///
int main(int argc, char* argv[]);
///
/// \brief constructFullConfigFileName построить полное имя файла конфигурации
/// \param fullname полное имя
/// \param size размер
/// \param name имя
///
void constructFullConfigFileName(char* fullname, int size, char* name);
///
/// \brief readConfigFile чтение конфигурации из файла
/// \param fullname полное имя файла конфигурации
/// \param params параметры теста
/// \return код результата
///
int readConfigFile(char* fullname, struct TParamCTest2* params);
///
/// \brief procCTest2 процедура консольного теста 2
/// \param params параметры теста
///
void procCTest2(struct TParamCTest2 params);
///
/// \brief initLogCTest2 настройка логов теста 2
///
void initLogCTest2(void);
///
/// \brief loadMemCTest2 загрузить mem файл
/// \param ram
///
void loadMemCTest2(RAM_BLOCK* ram);
///
/// \brief constructMemDataCTest2 подготовка данных
/// \param ram
///
void constructMemDataCTest2(RAM_BLOCK* ram);

#endif // CTEST1_H
